<?php

return function (
    $redirect = '/',
    $return = true
) {
    return [
        'POST' => function (string $username, string $password) use ($redirect, $return) {
            $user = wp_authenticate($username, $password);

            if (!is_wp_error($user)) {
                wp_clear_auth_cookie();
                wp_set_current_user($user->data->ID);
                wp_set_auth_cookie($user->data->ID);

                $dest = ($return and isset($_GET['return_to']))
                    ? $_GET['return_to'] : $redirect;

                return $dest;
            } else {
                return [
                    'error' => strip_tags($user->get_error_message()),
                    'state.username' => (string) $username
                ];
            }
        },
        'GET?signout' => function () {
            wp_destroy_current_session();
            wp_clear_auth_cookie();
            wp_set_current_user(0);

            return true;
        }
    ];
};
