<?php

return function (
    $redirect = '/'
) {
    return [
        'POST' => function (
            string $name,
            string $email,
            string $password,
            string $confirm
        ) use ($redirect) {
            if($password !== $confirm)
                return [
                    'error' => 'Passwords don\'t match',
                    'state.name' => $name,
                    'state.email' => $email,
                ];

                $result = wp_create_user($name, $password, $email);

            if(is_wp_error($result)) {
                return ['error' => $result->get_error_message()];
            } else {
                $user = get_user_by('id', $result);
                wp_clear_auth_cookie();
                wp_set_current_user($user->data->ID);
                wp_set_auth_cookie($user->data->ID);

                return <<<HTML
                Account created!
                <script>
                    window.location = '$redirect';
                </script>
                HTML;
            }
        }
    ];
};
