<?php

return function (
    $redirect = '/sign-in',
    $return = true
) {
    $verify = function () use ($redirect, $return)  {
        if (is_user_logged_in()) return null;
        
        $dest = '/' . trim($redirect, '/');
        
        if($return)
            $dest .= '?return_to=' . urlencode($_SERVER['REQUEST_URI']);
        
        return $dest;
    };

    return [
        'GET' => $verify,
        'POST' => $verify,
        'PUT' => $verify,
        'PATCH' => $verify,
        'DELETE' => $verify
    ];
};
